package net.p0f.k8s.demo.apiclient;

import java.util.List;

import jakarta.ws.rs.Consumes;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.HeaderParam;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.PathParam;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.core.MediaType;

@Path("/apis/batch/v1")
public interface ApiClient {
    @POST
    @Path("/namespaces/{namespace}/jobs")
    @Consumes("application/json")
    @Produces(MediaType.APPLICATION_JSON)
    String createJob(@HeaderParam("Authorization") String token,
                     @PathParam("namespace") String namespace,
                     String job);

    @GET
    @Path("/namespaces/{namespace}/jobs/{job}")
    @Produces(MediaType.APPLICATION_JSON)
    String getJob(@HeaderParam("Authorization") String token,
                  @PathParam("namespace") String namespace,
                  @PathParam("job") String jobName);

    @GET
    @Path("/namespaces/{namespace}/jobs")
    @Produces(MediaType.APPLICATION_JSON)
    List<String> getAllJobs(@HeaderParam("Authorization") String token,
                            @PathParam("namespace") String namespace);
}
