package net.p0f.k8s.demo.apiclient;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import org.jboss.logging.Logger;

import jakarta.ws.rs.client.ClientRequestContext;
import jakarta.ws.rs.client.ClientResponseContext;
import jakarta.ws.rs.client.ClientResponseFilter;

public class ResponseFilter implements ClientResponseFilter {
    final Logger LOG = Logger.getLogger(ResponseFilter.class.getName());

    @Override
    public void filter(ClientRequestContext requestContext, ClientResponseContext responseContext) throws IOException {
        LOG.info("Original request: " + requestContext.getMethod() + " " + requestContext.getUri());
        LOG.info("Request Headers:");
        requestContext.getHeaders().forEach((k, v) -> {
            LOG.info(k + ": " + v);
        });
        if (requestContext.getEntity() != null) {
            LOG.info("Request payload:");
            LOG.info(requestContext.getEntity().toString());
        } else {
            LOG.info("Request payload empty.");
        }
        LOG.info("Got response: HTTP/" + responseContext.getStatus());
        LOG.info("Response Headers:");
        responseContext.getHeaders().forEach((k, v) -> {
            LOG.info(k + ": " + v);
        });
        LOG.info("Response Body:");
        BufferedReader br = new BufferedReader(new InputStreamReader(responseContext.getEntityStream()));
        br.lines().forEach((l) -> {
            LOG.info(l);
        });
    }
}
